\documentclass{report}
\usepackage[T1]{fontenc}
\usepackage[utf8]{inputenc}
\usepackage[english]{babel}
\usepackage[a4paper, top=2.5cm, bottom=2.5cm, left=2.5cm, right=2.5cm]{geometry}
\usepackage{fancyhdr}
\pagestyle{fancy}
\lhead{\textbf{Machine Learning \& Artifical Intelligence}}
\rhead{Homework 01}
\lfoot{Enrico Franco}
\rfoot{Politecnico di Torino}
\usepackage{graphicx}					% Images
\usepackage{subcaption}
\usepackage{booktabs}					% Tables
\usepackage[hidelinks]{hyperref}		% Links
\author{Enrico Franco}
\title{Machine Learning \& Artifical Intelligence \\ Homework 01}

\begin{document}
\section*{Data preparation}
The complete dataset contains 189 dog images, 186 guitar images, 280 house images and 432 person images. In order to facilitate computation and to avoid biasing towards classes containing more samples, only 100 images for class are selected during the reading phase. Before any kind of computation, the dataset is normalized by subtracting its mean and dividing by its standard deviation.

\section*{PCA}
An image in the dataset is randomly chosen and re-projected using only some of its components. It is possible to notice that 2 PC and 6 PC do not provide particularly useful information about the image, while with 60 principal components it is possible to observe the original shape of the image and colors are quite similar to the original ones. Last 6 PC do not provide \emph{any} information about the original image, in fact the image is often represented as a grey box.

Figure~\ref{img:images} shows the reconstruction of an image for each category. First, the original image is plotted, that its projecton using first 2, 6, 60 principal components, while last image is the projection on the last 6 components.

\begin{figure}
\centering
	\begin{minipage}{.20\textwidth}
	\centering
	\includegraphics[scale=0.7, angle=270]{guitar.jpg}
	\subcaption{Guitar}
	\end{minipage}
	\quad
	\begin{minipage}{.20\textwidth}
	\centering
	\includegraphics[scale=0.7, angle=270]{person.jpg}
	\subcaption{Person}
	\end{minipage}
	\quad
	\begin{minipage}{.20\textwidth}
	\centering
	\includegraphics[scale=0.7, angle=270]{house.jpg}
	\subcaption{House}
	\end{minipage}
	\quad
	\begin{minipage}{.20\textwidth}
	\centering
	\includegraphics[scale=0.7, angle=270]{dog.jpg}
	\subcaption{Dog}
	\end{minipage}
\caption{Images visualization}
\label{img:images}
\end{figure}

It is possible to verify the previous concept by analyzing the \emph{variance ratio}, whose plot is available in figure~\ref{img:cumulative_variance}. Informally, this number represents the quantity of information which is possible to correctly reconstruct. Observing the plot, it is possible to notice that with 60 PC, about 80\% of the image can be correctly reconstructed, while last components do not provide any information about the original image, justifying the grey image, because the function has already reached its maximum.

\begin{figure}[hbtp]
\centering
\includegraphics[scale=0.7]{cumulative_variance.jpg}
\caption{Cumulative variance}
\label{img:cumulative_variance}
\end{figure}

A possible, empiric way, to choose a number of components preserving data without much distorsion, is given by the plot. In fact, it shows that 90\% of the image is correctly reconstructed using about 100 PC.

\begin{figure}[hbtp]
\centering
\includegraphics[scale=0.7]{first_pcs.jpg}
\caption{First two principal components -- Scatter plot}
\end{figure}

\section*{Bayes classifier}
Bayes classifier is built using normalized data. Multiple runs are performed, in order to have a better estimation of the results, shown in table~\ref{tab:bayes_classifier}.

\begin{table}[hbtp]
\centering
\begin{tabular}{cc}
\toprule 
\textbf{Principal components} & \textbf{Score} \\ 
\midrule 
Original image & 75 \% \\ 
First 2 & 56 \% \\ 
3rd and 4th & 38 \% \\ 
First 4 & 65 \% \\ 
\bottomrule 
\end{tabular}
\caption{Bayes classifier -- Results}
\label{tab:bayes_classifier}
\end{table}
\end{document}
